; dfc3.asm
; dumps 'The Final Cartridge III'
; Version 1.1
; I need to copy each bank within memory, because the FC3 disk speeder
; trashes my cartridge bank selection

* = $0801

.INCLUDE SYSTEM.ASM

		; 10 PRINT"FC3DUMP CARTRIDGE DUMPER V1.1"
                .byte $26,$08,$0a,$00,$99,$22
                .text "FC3DUMP CARTRIDGE DUMPER V1.1"
                .byte $22,$00

		; 20 INPUT "<dn>ENTER FILENAME";N$
                .byte $40,$08,$14,$00,$85,$22,$11
                .text "ENTER FILENAME"
                .byte $22,$3b,$4e,$24,$00

		; 30 SYS2125
                .byte $4a,$08,$1e,$00,$9e,$32,$31,$32,$35,$00

		; (end of BASIC program)
                .byte $00,$00,$00


		JSR  copy_filename	; copy input parameter into filename
		JSR  open_file		; open the file for writing
		JSR  save_fc3
		JSR  close_file
		RTS


copy_filename	LDY  #$02
		LDA  ($2d),Y	; file name length
		STA  fnlength
		INY
		LDA  ($2d),Y	; file name, lb
		STA  $fb
		INY
		LDA  ($2d),Y	; file name, hb
		STA  $fc

		LDA  fnlength	; copy the filename to accessible RAM
		TAX
		LDY  #$00
cpfnL1		LDA  ($fb),Y
		STA  filename,Y
		INY
		DEX
		BNE  cpfnL1

		RTS


fnlength	.byte $00
filename	.text "FILENAME GOES HERE"



open_file	JSR  CLALL
		LDA  #$01
		LDX  $ba	; current device number
		TAY
		JSR  SETLFS	; SETLFS 1,FA,1
		LDA  fnlength
		LDX  #<filename
		LDY  #>filename
		JSR  SETNAM
		JSR  OPEN
		LDX  #$01
		JSR  CHKOUT	; redirect output to file
		RTS


close_file	LDA  #$01
		JSR  CLOSE
		JSR  CLALL
		RTS


save_fc3	LDA  #$40	; bank counter
save_fc3_L 	STA  bank
		STA  $dfff	; set FC3 ROM Bank
		JSR  copy_bank	; copy $8000-$bfff to $4000-$7fff
		LDA  #$40
		STA  $dfff	; restore standard bank
		JSR  save_bank	; save the bank to disk
		CLC
		LDA  bank
		ADC  #$01
		CMP  #$44
		BNE  save_fc3_L 
		RTS

bank		.byte $00


copy_bank	LDA  #$80	; source: $fb/$fc = $8000
		STA  $fc	; dest:   $fd/$fe = $4000
		LDA  #$40
		STA  $fe
		LDA  #$00
		STA  $fb
		STA  $fd
		LDY  #$00

copy_bank_L	LDA  ($fb),Y
		STA  ($fd),Y
		INY
		BNE  copy_bank_L
		INC  $fc
		INC  $fe
		LDA  $fc
		CMP  #$c0
		BNE  copy_bank_L
		RTS


save_bank	LDA  #$40	; save the copied bank to disk
		STA  $fc
		LDA  #$00
		STA  $fb
		LDY  #$00	; index

save_bank_L	LDA  ($fb),Y
		JSR  CHROUT	; write byte
		INY
		BNE  save_bank_L
		INC  $fc
		LDA  $fc
		CMP  #$80
		BNE  save_bank_L
		RTS
